/*======================================================================
DS1820 -      , ,  
         1-Wire-. 
     -55C  +125C.   
   0,5C     -0C  +70C.
    ,     
        
   0,01C.     ~500 .
       
       .  , 
        
 1-Wire-          
 .      ,  
       
   1-Wire-.    64- 
  (  010)       
 ,      1-Wire-.   
       4,5   5,5 .  
     PR-35   16-   
    SSOP (DS1820S).      
 DS1820   DS18S20,     
     ,     
 .
-----------------------------------------------------------------------------
DS18B20 -      1-Wire-
    .   
  -55C  +125C.       
         
 .     
        9  12   .   
    . 12  - 750 , 11 - 325 , 10 - 187,5   
9  - 93,75 .
     PAR         
 .  ,     .    
    .        
  .
     0,5C    
  -10C  +85C.    12-  
  ~750 .     
         .
  ,       
   1-Wire-        
   .  1-Wire-    ,
       
     1-Wire-.    
 64-   (  028) (  DS1820 =010)
   
     ,     
 1-Wire-.        
   3,0   5,5 
== - ?
>>- . 
&- 
|- 
&&- 
||- 
?:-
~-  

DS18B20     9  12       : sssss0000000.0000
 DS1820 (  DS18S20)      9       DS18B20 : ssssssss0000000.0
 ,  s - sign -  1 - , 0 -  ,  ...

!!!!!!!!!      !!!!        datashet  !!!!!!!!!!!!   DS18B20.pdf   .   DS18B20  ,       : LSB  MSB, .. 16  ( 0-  15- )
 -16 (    .    1,     0)
sssss -   MSB    
     - (4-10)       (    0  128)
 -  LSB(0-3)      
: 5+7+4=16 , ..     .
 7+4=11, ..   ! (0-10)    !!!!!! 
    ,         , ..      (4 )

              
      

   DS1820, ..  sssssss0 0000000.0
 -0,5 = 11111111 1111111.1         
    1     .  :
 000000000000000.0 + 000000000000000.1 = 000000000000000.1 = 0,5 (     ).
      :
 -25 = 11111111 1100111.0
00000000 0011000.1
 00000000 0000000.1
 ------------------------------
 00000000 0011001.0 = 019 = 25
       :      
     . ..   .  1    
!!!  ( 0,1,2  DS18B20    ) ,     .

       -   
   !!! 
        ,    10   n,   -    .
 ,   73.5*.       73  5,  735,   
. ..        -   :
0000 0000 1001 0011 = 147,   735,       5:
0000 0000 1001 0011 * 101 = 1011011111   -     735
   ,         .
           COM      
 1-Wire "Temp Keeper"

************* !!!         16F84 & 4MHz!!!*****************

     DS18B20.
1),      DS18B20  
2)         480 .
3)  . DS18B20  .     
 "1" ( 15-60) DS18B20 ,       60-240
4)   
   )  0,  1 - 15 .
   )      .    
        60 - 120     
   )  1     1.    .   .
5)  ,       ,    5   
Skip ROM [CCh].        ,    1 , 
Read ROM [33h]             
  Read ROM,     64- ,    . 
              
 6)       1 - 15    1.
 7)  1-0 DS18B20    .
 8)         15    1-0
      .     .   
   6   ,   .      (CRC)
       : Convert T    
   Read Scratchpad   .
    ,   
       .
   Skip ROM [CCh].
   Convert T [44h].
    750.
       .
   Skip ROM [CCh].
   Read Scratchpad [BEh].
      (8 )  CRC.
  CRC,     ,  .
*/

#BYTE TRISA=0x85//   
#BYTE PORTA=0x5
#BYTE STATUS=0x3
#define RP0  5
#define C 0


// The following are standard 1-Wire routines.

void make_ds1820_high_pin(int sensor)
{
   TRISA = 0xff;//      .   
   //..   .      ,    
}

void make_ds1820_low_pin(int sensor)
{
   PORTA = 0x00; // 0    
   
   TRISA = 0xff & (~(0x01 << sensor));
}


// delay routines   4?
void delay_10us(int t)
{
#asm
            BCF STATUS, RP0
 DELAY_10US_X:
            CLRWDT
            NOP
            NOP
            NOP
            NOP
            NOP
            NOP
            DECFSZ t, F
            GOTO DELAY_10US_X
#endasm
}

void delay_ms(long t)        // delays t millisecs
{
   do
   {
     delay_10us(100);
   } while(--t);
}

void init_ds1820(int sensor)
{
   make_ds1820_high_pin(sensor);
   make_ds1820_low_pin(sensor);
   delay_10us(500);

   make_ds1820_high_pin(sensor);
   delay_10us(500);//     1820
   #asm
      NOP//      
#endasm

}

int read_ds1820_one_byte(int sensor)//  
{
   int bitN, i_byte, temper, bitRA;// ,  
   bitRA = 0xff & (~(0x01<<sensor));//     
   for (bitN=0; bitN<8; bitN++)
   {
      PORTA=0x00;
      TRISA=bitRA;//pin=0. FE-RA0,FD-RA1,FB-RA2,F7-RA3,EF-RA5 
      TRISA=0xff;//   . pin=1.
#asm
      CLRWDT//       ?
      NOP
      NOP
#endasm
      temper=PORTA;// , .  ?????????
      if (temper & ~bitRA)
      {
        i_byte=(i_byte>>1) | 0x80;        // least sig bit first
      }
      else
      {
        i_byte=i_byte >> 1;
      }
      delay_10us(6);
   }
   return(i_byte);//   
}

void write_ds1820_one_byte(int byteCommand, int sensor)//
{
   int bitN, bitRA;
   //   8.       
   bitRA = 0xff & (~(0x01<<sensor));//   .0- . ~  
   for(bitN=0; bitN<8; bitN++)
   {
      if (byteCommand&0x01)//    = 1
      {
         PORTA=0;
         TRISA=bitRA; //pin=0 FE-RA0,FD-RA1,FB-RA2,F7-RA3,EF-RA5  // momentary low
         TRISA=0xff;//   . pin=1 60
         delay_10us(6);
      }

      else// 0
      {
          PORTA=0;
          TRISA=bitRA;//pin=0 60
          delay_10us(6);
          TRISA=0xff;//   . pin=1.
      }        //0xbe - 10111110  " "
      byteCommand=byteCommand>>1;//    0xcc - 11001100  " ROM",0x44-"  "1000100
   #asm
      NOP//      
#endasm
   
   }
}

int16 read_sensor(byte sensor)//       
//           
// !!!         ?
{          
        signed int16 t1;
        int buff[2], n;
//        int temp,temp_dec;
//        int1 flag_s;
int16 flag_s;
       /*
          DS18B20    
           :
1) 
2) ROM, ,  ROM
3) ,    
  .1
       ROM (F0h)  (ECh)
     , 
       ,       9 (12) .
      */
      init_ds1820(sensor);//1) 
      write_ds1820_one_byte(0xcc, sensor);// 2) ROM   0xcc -  " ROM", ..     
      write_ds1820_one_byte(0x44, sensor);// 3) ,  0x44 -  "  "
      //   0-    
      while (read_ds1820_one_byte(sensor)==0xff); //.    1   
      //read_ds1820_one_byte(sensor);
      
      init_ds1820(sensor);//1) 
      write_ds1820_one_byte(0xcc, sensor);// 2) ROM   0xcc -  " ROM"
      write_ds1820_one_byte(0x44, sensor);// 
      write_ds1820_one_byte(0xbe, sensor);//0xbe -   " "
      //for (n=0; n<9; n++) //    (9 !)  0  1 .
      for (n=0; n<9; n++) //    (9 )  0  1 .
//  18B20          
      {
         buff[n]=read_ds1820_one_byte(sensor);  // read DS1820
      }
  //
  //============ ========================
  //      2      .
   //   2  1820,   16(..   0.0625  12  )   18B20 (>>  )
   //m = ( (int)( byte0 << 8 ) | (int)( byte1) )
  // tm = tm >> 1   // 1820 
  //    ,         
  //      0,01C.
  // tm = tm >> 4   // 18B20           
  //      .
 // 
   // 0  1  18S20  18B20 !!!

   //  18B20: byte0,       byte1,    byte2, byte3, byte4,  byte5,  byte6, byte7,  byte8
   //                                     tempLSB,  tempMSB, Th,      Tl,        config,     FFh,   OCh,   CRS
// , tempLSB-  ,  tempMSB -   . 
//    12 (11,10,9)  ()
// 0  11,   12  15  -   (5 )
//      : +0,5   -0,5 
// +0,5 =  0000.0000.0000.1000  =  0008h
//-0.5  =  1111.1111.1111.0111  =  FFF8h
//         4,            // 4   
//
//  18S20(1820): byte0,       byte1,      byte2, byte3, byte4,  byte5,  byte6, byte7, byte8
   //                                              tempLSB,  tempMSB,   Th,      Tl,        FFh  ,     FFh,   OCh,    10h,      CRS
// , tempLSB-  ,  tempMSB -   .     9  ()
// 0  7,   8  15  -   (8)
//      : +0,5   -0,5 
// +0,5 =  0000.0000.0000.0001 =  0001h
//-0.5  =  1111.1111.1111.1111  =  FFFFh
//         1,            // 1   
/*
18B20: 
     ()   ,         . 
       (BIT4)  1  ,       .
       ,      0,0625( 12 ).    BIT0.
*/
  // ================  
/*
18S20(1820) :
  18S20(1820)      -25.0, ..    :1100 1110  :  1111 1111
,        , ( 18S20(1820)     MSB  1)     1 ((buff[1] & 0x1)==1)       1,   ,          , ..    :   (!)        , . ~( buff[0] ) + 1.  ~(1100 1110)=110001+1=110010.   1   110010>>1= 11001=25      .
   +25.0,   :0011 0010  :  0000 0000.      1 ((buff[1] & 0x1)==1).  =0, ..    .         1   110010>>1= 11001=25
*/

//!      if ((buff[1] & 0x1)==1)//      1,   
//!         temp_dec=0x10000000;
//!    temp=(~( buff[0] ) + 1) >>1;// ,   1,   1         .
//!      else //
//!         temp_dec=0x00000000;
//!   temp=( buff[0] ) >>1;
//!     
//!     t1=temp;
//!     t1=t1 | temp_dec;   //       
//!     return(t1);
//!
/*
DS18B20 :
  DS18B20      -25.0625C, ..    :0110 1111  :  1111 1110
,        , ( DS18B20  5-   MSB  1)     0 (buff[1] < 0)      =1  (  int buff[9]) ,   ,    ,          , ..    
       ,         tmp = ( buff[0] )+(int)( buff[1] <<8). 
*/

 //   2   .           
t1= buff[1]; //       (MSB),    8  . 
//: 00000000sssssxxx
// ,           (LSB)  
// MSB-  8  .: sssssxxx00000000.           (LSB). : sssssxxx

  t1=(t1<<8)+buff[0];
//printf("MSB:%4X  LSB:%4X t_:%4X \r\n",buff[1],buff[0], t1);  // %4X 0 (Hex)  
        flag_s=0b0000000000000000;//    ,  ,   
        if (t1<0) //  , ..     1, 
        {
     t1=-t1+1;flag_s=0b1000000000000000;//      , ..    , .. sssss=00000 
//!          .        ,    1
        }

        t1 =  t1 >> 4; //     (: sssss0000000.0000)  : 000000000xxx
 t1=t1 | flag_s;   //        : 000000000xxx   111100000xxx 

      return(t1);
}
