//.h  MPLAB IDE ,   P16F84A.INC  ASM
//.h  mikroC PRO for PIC .  P16F84A.c
//.h   PIC C Compiler
#include <16F84A.h>//      (   )  <> (   )
#use delay(clock=4000000) //   PIC C Compiler
#fuses NOWDT,XT, NOPUT, NOPROTECT
#use rs232(baud=9600, xmit=PIN_B2, rcv=PIN_B3) //   PIC C Compiler//,    PIN_B2  PIN_B3 ? 
#include "ds1820.c"
#include "ds1307.c"


//        main()
// #include         ( ,  h) 16F84A.h
//     , ,   
// #include "ds1820.c"       ( .c),     main()
// #include "16F84A.h"      -  ,         
// #include <16F84A.h>     <>-     ,    
// #define -  ()   135
// ,    CCS-PIC C Compiler:   138
// #bit, #byte, #case, #device   139, #fuse   139, #locate, #org, #opt, #priority, #reserve,
// #rom, #type, #use delay, #use XXX_io, #use i2s   144, #use rs232, #zero ram

//    CCS-PIC C   148


void main(void)
{
   int8 i,sec,min,hour; 	
   int16 tpx,all_tp;
   int8 tp,tpd;
   delay_ms(50);

   init_ds1307(); // initial DS1307

   // set second to 00 and enable clock(bit7=0)
   write_ds1307(0,0x00);   
   while(true) {	 
     printf("========================\r\n");	//  132 ,  while(true)  -    
     sec=read_ds1307(0);  // read second
     min=read_ds1307(1);  // read minute
     hour=read_ds1307(2); // read houre
     printf("%02X:%02X:%02X\r\n",hour,min,sec);	 
     for (i =0;i<5;i++) {	    	    
   	    all_tp=read_sensor(i);  // read temperature	     
	    tpx=all_tp;
	    tp=make8(tpx,1);
	    tpx=all_tp;
	    tpd=make8(tpx,0);	    
	    printf("Ch:%u = %03u.%u\r\n",i+1,tp,tpd);	    
	    delay_ms(500);
	}
   }
}
