#include "16F84A.h"
#use delay(clock=4000000)
#fuses NOWDT,XT, NOPUT, NOPROTECT
#use rs232(baud=9600, xmit=PIN_B2, rcv=PIN_B3)
#include "ds1820.c"
#include "ds1307.c"

void main(void)
{
   int8 i,sec,min,hour; 	
   int16 tpx,all_tp;
   int8 tp,tpd;
   delay_ms(50);
   init_ds1307(); // initial DS1307
   // set second to 00 and enable clock(bit7=0)
   write_ds1307(0,0x00);   
   while(true) {	 
     printf("========================\r\n");	   
     sec=read_ds1307(0);  // read second
     min=read_ds1307(1);  // read minute
     hour=read_ds1307(2); // read houre
     printf("%02X:%02X:%02X\r\n",hour,min,sec);	 
     for (i =0;i<5;i++) {	    	    
   	    all_tp=read_sensor(i);  // read temperature	     
	    tpx=all_tp;
	    tp=make8(tpx,1);
	    tpx=all_tp;
	    tpd=make8(tpx,0);	    
	    printf("Ch:%u = %03u.%u\r\n",i+1,tp,tpd);	    
	    delay_ms(500);
	}
   }
}
